class Item

  include Mongoid::Document
  include Mongoid::Timestamps
  include Mongoid::Tree
  include Mongoid::Tree::Ordering
  
  field :name
  field :path
  field :is_published, :type => Boolean, :default => false
  field :enabled_for, :type => Array, :default => nil
  field :menu_enabled_for, :type => Array, :default => nil
  field :title, localize: true
  field :sitemap_enabled, :type => Boolean, :default => true

 
  validates_format_of :name, :with => /^[0-9a-zA-Z\-_]+$/
  validates :name, :exclusion => { :in => LIST[:forbidden_item_names] }
  validates_uniqueness_of :name, :scope => :parent_id
  validates_presence_of :name
  validates_associated :parent, :children
  
  before_destroy :destroy_children
  after_rearrange :rebuild_path, :if => "parent_id_changed? || name_changed?"
  
  def enabled_for_lang(lang)
    enabled_for.include?(lang)
  end

  def self.find_by_name(item_name)
    Item.first(:conditions => { :name => item_name, :is_published => true })
  end

  def visible_children
    objects = self.children
    a = []
    if objects
      objects.each do |object|
        a << object if object.menu_enabled_for.nil? ? true : object.menu_enabled_for.include?(I18n.locale.to_s)
      end
    end
    a
  end

  def shift_to(new_parent, position)
    unless self.parent_id.to_s.eql?(new_parent) && self.position.eql?(position.to_i)
      new_parent = Item.find(new_parent)
      current_position_sibling = find_by_parent_and_position(new_parent, position.to_i)
      if current_position_sibling
        current_position_sibling.at_bottom? ? move_below(current_position_sibling) : move_above(current_position_sibling)
      elsif self.parent != new_parent
        self.parent = new_parent
        save!
      end
    end
   end
  
  protected
  
  def rebuild_path
    self.path = (self.ancestors_and_self - [Item.root]).collect{|x| x.name unless x.root?}.join('/')
  end

  def find_by_parent_and_position(parent, position)
    parent.children.detect{|child| child.position == position}
  end

  # Enable the validation for parent_id
  def validates_presence_of_parent_id?
    true
  end
    
end
